LINE_INI:   equ 0x5cb0      ; Dirección línea inicio
LINE_END:   equ 0x5cb1      ; Dirección línea fin

Lines:
ld      a, (LINE_INI)       ; A = línea inicio
and     0x1f                ; A = línea
ld      b, a                ; B = línea
ld      a, (LINE_END)       ; A = línea fin
and     0x1f                ; A = línea
sub     b                   ; A = A - B, total líneas
inc     a                   ; A = A + 1, total líneas > 0
ld      b, a                ; B = total líneas

FisrtScanLine:
ld      a, (LINE_INI)       ; A = línea fin
and     0x18                ; A = tercio
or      0x40                ; A = 010TT000
ld      h, a                ; A = 010TT000
ld      a, (LINE_INI)       ; A = línea inicio
and     0x07                ; A = línea
rrca
rrca
rrca                        ; A = LLL00000
ld      l, a                ; L = LLL00000, HL = 010TT000 LLL0000

ld      a, (LINE_INI)       ; A = línea inicio
and     0x80                ; A >= 128
jr      nz, ScrollChr       ; Sí, salta

; Scroll
ScrollPx:
push    hl                  ; Preserva HL
ld      e, 0x08             ; E = 8 scanlines por línea
scrollPx_scan:
ld      c, 0x20             ; C = 32 columnas
ld      a, l                ; A = línea (LLL0000)
or      0x1f                ; A = línea y columna 31 (LLL11111)
ld      l, a                ; L = línea y columna 31 (LLL11111)
scrollPx_col:
rl      (hl)                ; Rota dirección HL
dec     l                   ; L-= 1, columna anterior
dec     c                   ; C-= 1
jr      nz, scrollPx_col    ; C <> 0, salta
inc     l                   ; L+= 1, columna posterior
jr      nc, scrollPx_scanCon ; RL (HL) no acarreo, salta
ld      a, l                ; A = línea
or      0x1f                ; A = línea y columna 31 (LLL11111)
ld      l, a                ; L = línea y columna 31 (LLL11111)
set     0x00, (hl)          ; Activa último bit scanline
scrollPx_scanCon:
inc     h                   ; H+= 1, siguiente scanline
dec     e                   ; E-= 1
jr      nz, scrollPx_scan   ; E <> 0, salta
scrollPx_NextLine:
pop     hl                  ; Recupera HL
ld      a, l                ; A = línea
add     a, 0x20             ; A+= 1 línea
ld      l, a                ; L = nueva línea
jr      nc, scrollPx_end    ; A + 0x20 no acarreo, salta
ld      a, h                ; A = 010TT000
add     a, 0x08             ; A+= 1 tercio
ld      h, a                ; H = nuevo tercio
scrollPx_end:
djnz    ScrollPx            ; B-= 1, B <> 0 , salta
ret                         ; Vuelve a BASIC

ScrollChr:
push    bc                  ; Preserva BC
push    hl                  ; Perserva HL
ld      e, 0x08             ; E = 8 scanlines por línea
scrollChr_scan:
push    hl                  ; Perserva HL
push    de                  ; Perserva DE
ld      a, (hl)             ; A = valor dirección HL
ld      d, h                ; D = H
ld      e, l                ; E = L
inc     l                   ; L+= 1, siguiente columa
ld      bc, 0x1f            ; B = 31 columnas
ldir                        ; Desplaza bytes
dec     hl                  ; HL-= 1, columna 31
ld      (hl), a             ; Columna 31 = valor anterior columna 0
pop     de                  ; Recupera DE                     
pop     hl                  ; Recupera HL
inc     h                   ; H+= 1, scanline siguiente
dec     e                   ; E-=1
jr      nz, scrollChr_scan  ; E <> 0, salta
scrollChr_attr:
pop     hl                  ; Recupera HL
push    hl                  ; Preserva HL
ld      a, h                ; A = H, 010TTSSS
and     0x18                ; A = 000TTSSS
rra
rra
rra                         ; A = 000000TT
or      0x58                ; A = 010110TT
ld      h, a                ; H = A
ld      d, h                ; D = H, HL = dirección atributo
ld      e, l                ; E = L
ld      bc, 0x1f            ; BC = 31 columnas
ld      a, (hl)             ; A = atributo columna 1
inc     l                   ; L+= 1, columna siguiente
ldir                        ; Desplaza atributos
dec     hl                  ; HL-= 1, columna 31
ld      (hl), a             ; Columna 31 = atributos borde
scrollChr_NextLine:
pop     hl                  ; Recupera HL
ld      a, l                ; A = línea
add     a, 0x20             ; A+= 1 línea
ld      l, a                ; L = nueva línea
jr      nc, scrollChr_end   ; A + 0x20 no acarreo, salta
ld      a, h                ; A = tercio
add     a, 0x08             ; A+= 1 tercio
ld      h, a                ; H = nuevo tercio
scrollChr_end:
pop     bc                  ; Recupera BC
djnz    ScrollChr           ; B-= 1, B <> 0, salta
ret                         ; Vuelve a BASIC
